
//int par(float *a, int cols, float sign, long long *tempo, MPI_Comm new_comm)
int par(float *a, int cols, float sign, long long *tempo, MPI_Comm new_comm, float *b)
{
	int rows, size, rank, i;
	float *w;
//	long_long start_usec, end_usec;
long long start_usec, end_usec;
//time senza papi
 struct timeval tvBegin, tvEnd, tvDiff;
//fine mod
	void cffti();
	void FFT2D(float *a, float *w, float sign, int rows, int cols, MPI_Comm new_comm);
//	int EventSet = PAPI_NULL;
	MPI_Status stat;

	MPI_Comm_size(new_comm, &size);
	MPI_Comm_rank(new_comm, &rank);



	rows = cols / size;
	
	w = (float *) malloc(2 * cols * sizeof(float));

	/*attende che tutti abbiano finito di leggere la propria parte di file*/
//inizio mod

//comm papi
	if (rank == 0){
gettimeofday(&tvBegin, NULL);
//		if (PAPI_library_init(PAPI_VER_CURRENT) != PAPI_VER_CURRENT)
//			exit(1);
//	
//		/* Gets the starting time in microseconds */
//		start_usec = PAPI_get_real_usec();
//
//		/*Create an EventSet */
//		if (PAPI_create_eventset(&EventSet) != PAPI_OK)
//			exit(1);
	}
//fine mod

	MPI_Scatter(a, 2 * rows * cols, MPI_FLOAT, b, 2 * rows * cols, MPI_FLOAT, 0, new_comm);
	
//	MPI_Barrier(new_comm);

	/*inizializziamo l'array dei twiddle factors*/
	cffti(cols, w);
//passato b anziche a alla funzione FFT2D
//	sign = 1.0; passato come argomento
	FFT2D(b, w, sign, rows, cols, new_comm);

	free(w);

	
	MPI_Barrier(new_comm);

//invertito b ed a passati alla gather
MPI_Gather(b, 2 * rows * cols, MPI_FLOAT, a, 2 * rows * cols, MPI_FLOAT, 0, new_comm);	

//inizio mod


//comm papi		
	if (rank == 0) {
gettimeofday(&tvEnd, NULL);
//		/* Gets the ending time in microseconds */
//		end_usec = PAPI_get_real_usec();
timeval_subtract(&tvDiff, &tvEnd, &tvBegin);
tempo[0] = tvDiff.tv_sec * 1000000LL + tvDiff.tv_usec;
//		tempo[0] = end_usec - start_usec;
//		printf("TRASFORMATA TERMINATA\n");
	}
//fine mod	
//	MPI_Gather(a, 2 * rows * cols, MPI_FLOAT, a, 2 * rows * cols, MPI_FLOAT, 0, new_comm);
//salvo in b
	return 0;	
}

void FFT2D(float *a, float *w, float sign, int rows, int cols, MPI_Comm new_comm) {
	int i, offset;
	float *pa;
	void Xpose();
	void cfft2();

	for (i = 0; i < rows; i++) {
		offset = 2 * i * cols;
		pa = a + offset;
		cfft2(cols, pa, w, sign);
	}

	Xpose(a, cols, new_comm);
	for (i = 0; i < rows; i++) {
		offset = 2 * i * cols;
		pa = a + offset;
		cfft2(cols, pa, w, sign);
	}
	Xpose(a, cols, new_comm);
}

void Xpose(float *a, int n, MPI_Comm new_comm) {
	float t0, t1;
	static float *buf_io;//, *buf_out; non viene usato
	int i, ij, is, j, step, n2, nn;
	static int init = -1;
	int size, rank, other;
	MPI_Status stat;

	MPI_Comm_size(new_comm, &size);
	MPI_Comm_rank(new_comm, &rank);

	/* number of local rows of 2D array */
	nn = n / size;
	n2 = 2 * nn;

	if (init != n) {
		buf_io = (float *) malloc(nn * n2 * sizeof(float));
		init = n;
	}

	/* local transpose of first block (in-place) */
	for (i = 0; i < nn - 1; i++) {
		for (j = (i+1) * 2; j < n2; j += 2) {
			t0 = a[rank * n2 + j * n + i * 2];
			t1 = a[rank * n2 + j * n + i * 2 + 1];
			a[rank * n2 + j * n + i * 2] = a[rank * n2 + i * 2 * n + j];
			a[rank * n2 + j * n + i * 2 + 1] = a[rank * n2 + i * 2 * n + j + 1];
			a[rank * n2 + i * 2 * n + j] = t0;
			a[rank * n2 + i * 2 * n + j + 1] = t1;
		}
	}
	

	/* size-1 communication steps */
	for (step = 1; step < size; step++) {
		other = rank ^ step;

		/* fill send buffer */
		ij = 0;
		for (i = 0; i < nn; i++) {
			is = other * n2 + i * 2 * n;
			for (j = 0; j < n2; j++) {
				buf_io[ij++] = a[is + j];
			}
		}
		/* exchange data */
		MPI_Sendrecv_replace(buf_io, 2 * nn * nn, MPI_FLOAT, other, rank, other, other, new_comm, &stat);

		/* write back recv buffer in transposed order */
		for (i = 0; i < nn; i++) {
			for (j = 0; j < nn; j++) {
				a[other * n2 + j * 2 * n + i * 2] = buf_io[i * n2 + j * 2];
				a[other * n2 + j * 2 * n + i * 2 + 1] = buf_io[i * n2 + j * 2 + 1];
			}
		}
	}
}

void cffti(n, w)
	int n;float w[][2]; {
	int i;
	float pi, arg, t;

	pi = 3.141592653589793;
	t = 2.0 * pi / ((float) n);
	for (i = 0; i < n / 2; i++) {
		arg = t * ((float) i);
		w[i][0] = cos(arg);
		w[i][1] = sin(arg);
	}
}

void cfft2(n, x, w, sign)
	int n;float sign, x[][2], w[][2]; {
	int n2, m, j, mj, p2, p3, p4;
	void step0(), step1(), step2();

	m = (int) (log((float) n) / log(1.99));

	mj = 1;
	n2 = n / 2;

	for (j = 0; j < m; j++) {
		if (j < (m + 1) / 2) {
			p2 = n2 / mj;
			step0(n, mj, &x[0][0], &x[p2][0], w, sign);
		} else {
			p2 = n2 / mj;
			p3 = mj;
			p4 = p2 + mj;
			step1(n, mj, &x[0][0], &x[p2][0], &x[p3][0], &x[p4][0], w, sign);
		}
		mj = 2 * mj;
	}
}
void step0(n, mj, a, b, w, sign)
	int n, mj;float a[][2], b[][2], w[][2];float sign; {
	float wkr, wku, wambr, wambu;
	int i, k, kw, lj, ii, ij;

	lj = n / (2 * mj);
	ij = n / mj;
	for (i = 0; i < mj; i++) {
		ii = i * ij;
		if (sign > 0.) {
			for (k = 0; k < lj; k++) {
				kw = k * mj;
				wkr = w[kw][0];
				wku = w[kw][1];
				wambr = wkr * (a[ii + k][0] - b[ii + k][0]) - wku * (a[ii + k][1] - b[ii + k][1]);
				wambu = wku * (a[ii + k][0] - b[ii + k][0]) + wkr * (a[ii + k][1] - b[ii + k][1]);
				a[ii + k][0] = a[ii + k][0] + b[ii + k][0];
				a[ii + k][1] = a[ii + k][1] + b[ii + k][1];
				b[ii + k][0] = wambr;
				b[ii + k][1] = wambu;
			}
		} else {
			for (k = 0; k < lj; k++) {
				kw = k * mj;
				wkr = w[kw][0];
				wku = -w[kw][1];
				wambr = wkr * (a[ii + k][0] - b[ii + k][0]) - wku * (a[ii + k][1] - b[ii + k][1]);
				wambu = wku * (a[ii + k][0] - b[ii + k][0]) + wkr * (a[ii + k][1] - b[ii + k][1]);
				a[ii + k][0] = a[ii + k][0] + b[ii + k][0];
				a[ii + k][1] = a[ii + k][1] + b[ii + k][1];
				b[ii + k][0] = wambr;
				b[ii + k][1] = wambu;
			}
		}
	}
}

void step1(n, mj, a, b, c, d, w, sign)
	int n, mj;float a[][2], b[][2], c[][2], d[][2], w[][2];float sign; {
	float wkr, wku, wambr, wambu, wcmdr, wcmdu;
	int mj2, i, j, k, kw, lj;

	mj2 = 2 * mj;
	lj = n / mj2;

	for (j = 0; j < mj; j += n / mj) {
		if (sign > 0.) {
			for (i = j; i < n; i += mj2) {
				for (k = 0; k < lj; k++) {
					kw = k * mj;
					wkr = w[kw][0];
					wku = w[kw][1];
					wambr = wkr * (a[i + k][0] - b[i + k][0]) - wku * (a[i + k][1] - b[i + k][1]);
					wambu = wku * (a[i + k][0] - b[i + k][0]) + wkr * (a[i + k][1] - b[i + k][1]);
					a[i + k][0] = a[i + k][0] + b[i + k][0];
					a[i + k][1] = a[i + k][1] + b[i + k][1];
					b[i + k][0] = c[i + k][0] + d[i + k][0];
					b[i + k][1] = c[i + k][1] + d[i + k][1];
					wcmdr = wkr * (c[i + k][0] - d[i + k][0]) - wku * (c[i + k][1] - d[i + k][1]);
					wcmdu = wku * (c[i + k][0] - d[i + k][0]) + wkr * (c[i + k][1] - d[i + k][1]);
					c[i + k][0] = wambr;
					c[i + k][1] = wambu;
					d[i + k][0] = wcmdr;
					d[i + k][1] = wcmdu;
				}
			}
		} else {
			for (i = j; i < n; i += mj2) {
				for (k = 0; k < lj; k++) {
					kw = k * mj;
					wkr = w[kw][0];
					wku = -w[kw][1];
					wambr = wkr * (a[i + k][0] - b[i + k][0]) - wku	* (a[i + k][1] - b[i + k][1]);
					wambu = wku * (a[i + k][0] - b[i + k][0]) + wkr	* (a[i + k][1] - b[i + k][1]);
					a[i + k][0] = a[i + k][0] + b[i + k][0];
					a[i + k][1] = a[i + k][1] + b[i + k][1];
					b[i + k][0] = c[i + k][0] + d[i + k][0];
					b[i + k][1] = c[i + k][1] + d[i + k][1];
					wcmdr = wkr * (c[i + k][0] - d[i + k][0]) - wku	* (c[i + k][1] - d[i + k][1]);
					wcmdu = wku * (c[i + k][0] - d[i + k][0]) + wkr	* (c[i + k][1] - d[i + k][1]);
					c[i + k][0] = wambr;
					c[i + k][1] = wambu;
					d[i + k][0] = wcmdr;
					d[i + k][1] = wcmdu;
				}
			}
		}
	}
}
